﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;
using System.IO;

namespace controlcenter
{
    public partial class Profiles : Form
    {

        #region default xml file
        string defaultfile = @"<Profile>
  <button>
    <name>up</name>
    <mode>Xbox Input Mode</mode>
    <value>Up</value>
  </button>
  <button>
    <name>down</name>
    <mode>Xbox Input Mode</mode>
    <value>Down</value>
  </button>
  <button>
    <name>left</name>
    <mode>Xbox Input Mode</mode>
    <value>Left</value>
  </button>
  <button>
    <name>right</name>
    <mode>Xbox Input Mode</mode>
    <value>Right</value>
  </button>
  <button>
    <name>start</name>
    <mode>Xbox Input Mode</mode>
    <value>Start</value>
  </button>
  <button>
    <name>select</name>
    <mode>Xbox Input Mode</mode>
    <value>Back</value>
  </button>
  <button>
    <name>l1</name>
    <mode>Xbox Input Mode</mode>
    <value>LB</value>
  </button>
  <button>
    <name>l2</name>
    <mode>Xbox Input Mode</mode>
    <value>LT</value>
  </button>
  <button>
    <name>l3</name>
    <mode>Xbox Input Mode</mode>
    <value>LS</value>
  </button>
  <button>
    <name>r1</name>
    <mode>Xbox Input Mode</mode>
    <value>RB</value>
  </button>
  <button>
    <name>r2</name>
    <mode>Xbox Input Mode</mode>
    <value>RT</value>
  </button>
  <button>
    <name>r3</name>
    <mode>Xbox Input Mode</mode>
    <value>RS</value>
  </button>
  <button>
    <name>cross</name>
    <mode>Xbox Input Mode</mode>
    <value>A</value>
  </button>
  <button>
    <name>circle</name>
    <mode>Xbox Input Mode</mode>
    <value>B</value>
  </button>
  <button>
    <name>square</name>
    <mode>Xbox Input Mode</mode>
    <value>X</value>
  </button>
  <button>
    <name>triangle</name>
    <mode>Xbox Input Mode</mode>
    <value>Y</value>
  </button>
  <digital_triggers>
    <value>False</value>
  </digital_triggers>
  <axis>
    <name>X-Axis</name>
    <value>LX</value>
  </axis>
  <axis>
    <name>Y-Axis</name>
    <value>LY</value>
  </axis>
  <axis>
    <name>RX-Axis</name>
    <value>RX</value>
  </axis>
  <axis>
    <name>RY-Axis</name>
    <value>RY</value>
  </axis>
</Profile>";
        #endregion

        string[] modes ={
                           "Xbox Input Mode",
                           "Mouse Buttons",
                           "Keyboard Input",
                           "Macro Mode"
                       };
        string[] axes = {
                            "LX",
                            "LY",
                            "RX",
                            "RY",
                            "Tilt-X",
                            "Tilt-Y",
                            "Tilt-Z"
                        };


        
        string[] xbox360mode ={
                                 "Up",
                                 "Down",
                                 "Left",
                                 "Right",
                                 "A",
                                 "B",
                                 "X",
                                 "Y",
                                 "Back",
                                 "Start",
                                 "LB",
                                 "RB",
                                 "LT",
                                 "RT",
                                 "LS",
                                 "RS",
                             };

        string[] mousemode ={
                                 "Left",
                                 "Right",
                                 "Middle",
                                 "Back",
                                 "Forward",
                                 "Scroll Up",
                                 "Scroll Down",
                              };

        string[] keyboardmode ={
                                  "BACKSPACE",
                                  "DEL or DELETE",
                                  "DOWN ARROW",
                                  "LEFT ARROW",
                                  "END",
                                  "ENTER",
                                  "ESC",
                                  "HOME",
                                  "INSERT",
                                  "NUM LOCK",
                                  "PAGE DOWN",
                                  "PAGE UP",
                                  "PRINT SCREEN",
                                  "RIGHT ARROW",
                                  "SCROLL LOCK",
                                  "TAB",
                                  "UP ARROW",
                                  "F1",
                                  "F2",
                                  "F3",
                                  "F4",
                                  "F5",
                                  "F6",
                                  "F7",
                                  "F8",
                                  "F9",
                                  "F10",
                                  "F11",
                                  "F12",
                                  "F13",
                                  "F14",
                                  "F15",
                                  "F16",
                                  "Keypad add",
                                  "Keypad subtract",
                                  "Keypad multiply",
                                  "Keypad divide",
                                  "0",
                                  "1",
                                  "2",
                                  "3",
                                  "4",
                                  "5",
                                  "6",
                                  "7",
                                  "8",
                                  "9",
                                  "a",
                                  "b",
                                  "c",
                                  "d",
                                  "e",
                                  "f",
                                  "g",
                                  "h",
                                  "i",
                                  "j",
                                  "k",
                                  "l",
                                  "m",
                                  "n",
                                  "o",
                                  "p",
                                  "q",
                                  "r",
                                  "s",
                                  "t",
                                  "u",
                                  "v",
                                  "w",
                                  "x",
                                  "y",
                                  "z"
                              };
                                  
                              
        public Profiles()
        {
            InitializeComponent();
        }

        private void Profiles_Load(object sender, EventArgs e)
        {
            foreach (Control cont in this.Controls)
            {
                if (cont is ComboBox)
                {
                    if (((ComboBox)cont).AccessibleName == "modes")
                    {
                        int x = modes.Length;
                        ((ComboBox)cont).Items.Clear();
                        for (int i = 0; i < x; i++)
                        {
                            ((ComboBox)cont).Items.Add(modes[i]);
                        }
                        ((ComboBox)cont).SelectedIndex = 0;
                    }

                    if (((ComboBox)cont).AccessibleName == "axis")
                    {
                        int x = axes.Length;
                        ((ComboBox)cont).Items.Clear();
                        for (int i = 0; i < x; i++)
                        {
                            ((ComboBox)cont).Items.Add(axes[i]);
                        }
                        ((ComboBox)cont).SelectedIndex = 0;
                    }
                }
            }
            profilemenu.SelectedIndex = 0;
            if (macrosmenu.Items.Count > 0)
                macrosmenu.SelectedIndex = 0;
            loadxmltoprofile();
            loadprofiles();
        }

        private void profilesave_Click(object sender, EventArgs e)
        {
            string temp = profilemenu.Text;
            bool duplicateflag = false;

            for (int i = 0; i < profilemenu.Items.Count; i++)
            {
                if (profilemenu.Items[i].ToString() == temp)
                {
                    profilemenu.SelectedItem = temp;
                    duplicateflag = true;
                }
            }
            if (!duplicateflag)
                profilemenu.Items.Add(temp);
           

            XmlDocument xmlDoc = new XmlDocument();//create xml document

            XmlNode rootNode = xmlDoc.CreateElement("Profile"); //create root node
            xmlDoc.AppendChild(rootNode);//append root node to file

            //create element under rootnode name=Profile
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "up", upmode.SelectedItem.ToString(), upvalue.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "down", downmode.SelectedItem.ToString(), downvalue.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "left", leftmode.SelectedItem.ToString(), leftvalue.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "right", rightmode.SelectedItem.ToString(), rightvalue.SelectedItem.ToString());

            createxmlchild_buttons(ref xmlDoc, ref rootNode, "start", startmode.SelectedItem.ToString(), startvalue.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "select", selectmode.SelectedItem.ToString(), selectvalue.SelectedItem.ToString());

            createxmlchild_buttons(ref xmlDoc, ref rootNode, "l1", l1mode.SelectedItem.ToString(), l1value.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "l2", l2mode.SelectedItem.ToString(), l2value.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "l3", leftbuttonmode.SelectedItem.ToString(), leftbuttonvalue.SelectedItem.ToString());

            createxmlchild_buttons(ref xmlDoc, ref rootNode, "r1", r1mode.SelectedItem.ToString(), r1value.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "r2", r2mode.SelectedItem.ToString(), r2value.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "r3", rightbuttonmode.SelectedItem.ToString(), rightbuttonvalue.SelectedItem.ToString());

            createxmlchild_buttons(ref xmlDoc, ref rootNode, "cross", crossmode.SelectedItem.ToString(), crossvalue.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "circle", circlemode.SelectedItem.ToString(), circlevalue.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "square", squaremode.SelectedItem.ToString(), squarevalue.SelectedItem.ToString());
            createxmlchild_buttons(ref xmlDoc, ref rootNode, "triangle", trianglemode.SelectedItem.ToString(), trianglevalue.SelectedItem.ToString());

            createxmlchild_digitaltriggers(ref xmlDoc, ref rootNode, digitaltriggers.Checked);

            createxmlchild_axis(ref xmlDoc, ref rootNode, "X-Axis", xaxis.SelectedItem.ToString());
            createxmlchild_axis(ref xmlDoc, ref rootNode, "Y-Axis", yaxis.SelectedItem.ToString());
            createxmlchild_axis(ref xmlDoc, ref rootNode, "RX-Axis", rxaxis.SelectedItem.ToString());
            createxmlchild_axis(ref xmlDoc, ref rootNode, "RY-Axis", ryaxis.SelectedItem.ToString());

            //save xml file
            xmlDoc.Save(temp + ".xml");
        }

        public void createxmlchild_buttons(ref XmlDocument doc, ref XmlNode parent, string elementname,string its_mode, string its_value)
        {
            XmlNode userNode = doc.CreateElement("button");

            XmlNode name = doc.CreateElement("name");
            name.InnerText = elementname;
            userNode.AppendChild(name);

            XmlNode mode = doc.CreateElement("mode");
            mode.InnerText = its_mode;
            userNode.AppendChild(mode);

            XmlNode value = doc.CreateElement("value");
            value.InnerText = its_value;
            userNode.AppendChild(value);

            parent.AppendChild(userNode);
        }

        public void createxmlchild_digitaltriggers(ref XmlDocument doc, ref XmlNode parent,bool value)
        {
            XmlNode userNode = doc.CreateElement("digital_triggers");
            XmlNode itsvalue = doc.CreateElement("value");
            itsvalue.InnerText = value.ToString();
            userNode.AppendChild(itsvalue);
            parent.AppendChild(userNode);
        }

        public void createxmlchild_axis(ref XmlDocument doc, ref XmlNode parent, string elementname, string its_value)
        {
            XmlNode userNode = doc.CreateElement("axis");

            XmlNode name = doc.CreateElement("name");
            name.InnerText = elementname;
            userNode.AppendChild(name);

            XmlNode value = doc.CreateElement("value");
            value.InnerText = its_value;
            userNode.AppendChild(value);

            parent.AppendChild(userNode);
        }

        public void loadxmltoprofile()
        {
            string filename = profilemenu.SelectedItem + ".xml";
            XmlDocument xmlDoc = new XmlDocument();
            if (!File.Exists(filename)) File.WriteAllText(filename, defaultfile);
            xmlDoc.Load(filename);
            try
            {
                XmlNodeList mainlist = xmlDoc.SelectNodes("//Profile/button");
                loadintoboxes_buttons(ref upmode, ref upvalue, mainlist, 0);
                loadintoboxes_buttons(ref downmode, ref downvalue, mainlist, 1);
                loadintoboxes_buttons(ref leftmode, ref leftvalue, mainlist, 2);
                loadintoboxes_buttons(ref rightmode, ref rightvalue, mainlist, 3);

                loadintoboxes_buttons(ref startmode, ref startvalue, mainlist, 4);
                loadintoboxes_buttons(ref selectmode, ref selectvalue, mainlist, 5);

                loadintoboxes_buttons(ref l1mode, ref l1value, mainlist, 6);
                loadintoboxes_buttons(ref l2mode, ref l2value, mainlist, 7);
                loadintoboxes_buttons(ref leftbuttonmode, ref leftbuttonvalue, mainlist, 8);

                loadintoboxes_buttons(ref r1mode, ref r1value, mainlist, 9);
                loadintoboxes_buttons(ref r2mode, ref r2value, mainlist, 10);
                loadintoboxes_buttons(ref rightbuttonmode, ref rightbuttonvalue, mainlist, 11);

                loadintoboxes_buttons(ref crossmode, ref crossvalue, mainlist, 12);
                loadintoboxes_buttons(ref circlemode, ref circlevalue, mainlist, 13);
                loadintoboxes_buttons(ref squaremode, ref squarevalue, mainlist, 14);
                loadintoboxes_buttons(ref trianglemode, ref trianglevalue, mainlist, 15);

                //load into checkbox
                XmlNode triggerstatus = xmlDoc.SelectSingleNode("//Profile/digital_triggers/value");
                digitaltriggers.Checked = Convert.ToBoolean(triggerstatus.InnerText);

                XmlNodeList axislist = xmlDoc.SelectNodes("//Profile/axis");
                loadintoboxes_axis(ref xaxis, axislist, 0);
                loadintoboxes_axis(ref yaxis, axislist, 1);
                loadintoboxes_axis(ref rxaxis, axislist, 2);
                loadintoboxes_axis(ref ryaxis, axislist, 3);
            }
            catch
            {
                MessageBox.Show("There is some error in Profile data. Loading default Profile");
                File.WriteAllText(filename, defaultfile);
                loadxmltoprofile();
            }
        }

        public void loadintoboxes_buttons(ref ComboBox modelist, ref ComboBox valuelist, XmlNodeList list,int index)
        {
            XmlNode mode = list[index].SelectSingleNode("mode");
            XmlNode value = list[index].SelectSingleNode("value");
            modelist.SelectedItem = mode.InnerText;
            valuelist.SelectedItem = value.InnerText;
        }

        public void loadintoboxes_axis(ref ComboBox valuelist, XmlNodeList list, int index)
        {
            XmlNode value = list[index].SelectSingleNode("value");
            valuelist.SelectedItem = value.InnerText;
        }


        private void SelectedIndexChanged(object sender, EventArgs e)
        {
            var ctrl = sender as ComboBox;
            var value = (ComboBox)this.Controls.Find(ctrl.AccessibleDescription, true)[0];
            switch (ctrl.SelectedItem.ToString())
            {
                case "Xbox Input Mode":
                    value.Items.Clear();
                    for (int i = 0; i < xbox360mode.Length; i++)
                    {
                        value.Items.Add(xbox360mode[i]);
                    }
                    break;
                case "Mouse Buttons":
                    value.Items.Clear();
                    for (int i = 0; i < mousemode.Length; i++)
                    {
                        value.Items.Add(mousemode[i]);
                    }
                    break;
                case "Keyboard Input":
                    value.Items.Clear();
                    for (int i = 0; i < keyboardmode.Length; i++)
                    {
                        value.Items.Add(keyboardmode[i]);
                    }
                    break;
                case "Macro Mode":
                    value.Items.Clear();
                    if (macrosmenu.Items.Count == 0)
                    {
                        MessageBox.Show("macro list is empty, Add a macro from below");
                        ctrl.SelectedItem = "Xbox Input Mode";
                    }
                    else
                    {
                        for (int i = 0; i < macrosmenu.Items.Count; i++)
                        {
                            value.Items.Add(macrosmenu.Items[i]);
                        }
                    }

                    break;
            }
            value.SelectedIndex = 0;
        }

        private void profileload_Click(object sender, EventArgs e)
        {
            loadxmltoprofile();
        }

        private void exit_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Exit?", "", MessageBoxButtons.YesNo) == DialogResult.Yes)
                Close();
        }

        private void profileactivate_Click(object sender, EventArgs e)
        {
            XmlDocument xmlDoc = new XmlDocument();//create xml document

            XmlNode rootNode = xmlDoc.CreateElement("Settings"); //create root node
            xmlDoc.AppendChild(rootNode);//append root node to file
            XmlNode userNode = xmlDoc.CreateElement("ActiveProfile");
            userNode.InnerText = profilemenu.Text;
            rootNode.AppendChild(userNode);

            xmlDoc.Save("Settings.xml");
        }

        public void loadprofiles()
        {
            string[] files = Directory.GetFiles(AppDomain.CurrentDomain.BaseDirectory, "*.xml");
            profilemenu.Items.Clear();
            for (int i = 0; i < files.Length; i++)
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(files[i]);
                string rootName = doc.SelectSingleNode("/*").Name;
                if (rootName == "Profile") profilemenu.Items.Add(Path.GetFileNameWithoutExtension(files[i]));
            }
        }

        private void profiledelete_Click(object sender, EventArgs e)
        {

        }

        private void macronew_Click(object sender, EventArgs e)
        {
            macrobox.Visible = true;
            deadzoneconfig.Visible = false;
        }

        private void btnsavemacro_Click(object sender, EventArgs e)
        {
            macrobox.Visible = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (deadzoneconfig.Visible == true)
                deadzoneconfig.Visible = false;
            else if (deadzoneconfig.Visible == false)
            {
                deadzoneconfig.Visible = true;
                macrobox.Visible = false;
            }
        }

        #region Trackbar deadzones
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            valaxisx.Text = trackBar1.Value.ToString() + "%";
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            valaxisy.Text = trackBar2.Value.ToString() + "%";
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            valaxisrx.Text = trackBar3.Value.ToString() + "%";
        }

        private void trackBar4_Scroll(object sender, EventArgs e)
        {
            valaxisry.Text = trackBar4.Value.ToString() + "%";
        }
        #endregion

        private void valaxis_KeyDown(object sender, KeyEventArgs e)
        {
            TextBox ctrl = sender as TextBox;
            TrackBar value = (TrackBar)this.Controls.Find(ctrl.AccessibleDescription, true)[0];
            if (e.KeyCode == Keys.Return)
            {
                int x = int.Parse(ctrl.Text);
                if (x <= 50)
                {
                    value.Value = x;
                }
                else
                {
                    MessageBox.Show("Enter a value from 0 to 50");
                }
                ctrl.Text = ctrl.Text + "%";
            }
        }

        private void valaxis_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!char.IsControl(e.KeyChar) && !char.IsDigit(e.KeyChar) && (e.KeyChar != '.'))
            {
                e.Handled = true;
            }
        }

    }
}
